# Tools for webget applications.

import os
import string
import re

base = "/home/azz/public_html/webget"
queuedir = base + "/queue/"
gotdir = base + "/got/"

def filenameof(url):
    return string.replace(url, "/", "@")

def urlof(filename):
    return string.replace(re.sub(r"^.*/([^/]*)$", r"\1", filename), "@", "/")

def extensionof(url):
    m = re.match(r"[a-z]*://[^/]+/.*\.([^.#\?/]*)([#\?]?.*)?", url)
    if not m: return ""
    return m.group(1)

def schemaof(url):
    m = re.match("^([^:]*)://[^/]+(/.*|)$", url)
    if not m: return ""
    return m.group(1)

# This would use urlparse.urljoin(), were it not so buggy...
def makeabsolute(url, base):
    if re.match("^[^:/]*:/",url) or url[0] == "#":
        return url
    if re.match("^[^:/]*:[^/]",url):
        url = re.sub("^[^:]*:", "", url)
    if url[0] == "/":
        result = re.match("(.*://[^/]*)",base)
        return result.group(1) + url
    if base[-1] != "/":
        base = base + "/"
    return re.sub(r"/[^/]*/\.\./", "/", base + url)

# Currently orders newest first
def orderfunc(x,y):
    if x[1]>y[1]:
        return -1
    elif x[1]==y[1]:
        return 0
    else:
        return 1

def orderdir(x):
    i = os.listdir(x)
    j = []
    for z in i:
        try:
            # This was [9] (ctime) originally; it's now mtime
            j.append((z, os.lstat(x + "/" + z)[8]))
        except:
            pass
    j.sort(orderfunc)
    return j

def remove(url):
    try:
        os.unlink(gotdir + filenameof(url))
    except:
        pass

def queue(url):
    if not schemaof(url) in ["http", "ftp"]: return 0
    try:
        os.symlink("../do-webget", queuedir + filenameof(url))
        return 1
    except:
        return 0
